SystemOrganization addCategory: #'PEGWiki-Model'!

Object subclass: #PWDictionaryModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

PWDictionaryModel class
	instanceVariableNames: 'storage'!

!PWDictionaryModel commentStamp: 'chc 3/23/2016 09:21' prior: 0!
This is a simple model with a dictionary in a class variable. It stands alone from the rest of the classes in this category. PWDictionaryModel is a simple model for a dictionary singleton. The rest of the classes work with PWSeasidePrefsModel for persistence based on the WAUserConfiguration classes in Seaside.!

PWDictionaryModel class
	instanceVariableNames: 'storage'!

!PWDictionaryModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/18/2016 22:43'!
storage
	^storage ! !

!PWDictionaryModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/18/2016 22:42'!
storage: anObject
	storage := anObject! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:46'!
readUserConfigurationsFrom: aStream
	| ini |
	ini _ INIFile readFrom: aStream.
	self registeredConfigurationsDo:
		[:config |
		(ini includesSection: config name) ifTrue:
			[config clear.
			(ini section: config name) associationsDo:
				[:assoc | assoc value ifNotNil:
					[(config hasAttributeNamed: assoc key)
						ifTrue: [config valueAt: assoc key put: assoc value]]]]]! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:20'!
writeUserConfigurationsOn: aStream
	| ini |
	ini _ INIFile new.
	self registry keysAndValuesDo:
		[:key :value | (ini section: key) addAll: value localValues].
	ini writeOn: aStream! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestors
	| temp linear |
	temp _ OrderedCollection new.
	linear _ OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear allButFirst asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/5/2004 13:21'!
groupedAttributes
	| dict sorted |
	dict _ Dictionary new.
	sorted _ SortedCollection sortBlock: [:a :b | a key <= b key].
	self allAttributes do:
		[:ea |
		(dict at: ea group ifAbsentPut: [SortedCollection sortBlock: [:a :b | a key <= b key]])
			add: ea].
	dict associationsDo:
		[:assoc |
		sorted add: assoc].
	^ sorted
		! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:32'!
ancestors
	^ Array with: (WARenderLoopConfiguration new)! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:12'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		
! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:07'!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: 'DeploymentMode'
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAGlobalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:39'!
initialize
	DeploymentMode ifNil: [self setDevelopmentMode]! !

!WAGlobalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:35'!
setDeploymentMode
	DeploymentMode _ true! !

!WAGlobalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:36'!
setDevelopmentMode
	DeploymentMode _ false! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 13:00'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol group: #server) options: #(http https))
		with: (WAStringAttribute key: #serverHostname group: #server)
		with: (WANumberAttribute key: #serverPort group: #server)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:35'!
deploymentMode
	^ DeploymentMode! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: (WASessionConfiguration new)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:30'!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent) options: self rootComponents)
		with: (WAStringAttribute key: #resourceBaseUrl group: #server)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:24'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:09'!
rootComponents
	^ (WAComponent allSubclasses select: [:ea | ea canBeRoot]) asSortedCollection: [:a :b | a name <= b name]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: WAGlobalConfiguration new! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 17:57'!
attributes
	^ Array
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass) options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)
		with: (WABooleanAttribute key: #useSessionCookie)! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:10'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/7/2004 13:59'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:20'!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/12/2005 21:42'!
useSessionCookie
	^ false! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance _ self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
new
	^ self instance! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:31'!
name
	^ self class name! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'values ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WAUserConfiguration subclass: #PWSeasidePrefsModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

PWSeasidePrefsModel class
	instanceVariableNames: 'instance'!

!PWSeasidePrefsModel commentStamp: 'chc 3/24/2016 09:33' prior: 0!
This is a persistence model based on the Seaside preferences database. It saves data in classes called Attributes, which are saved in a custom dictionary accessable with the selectors in WAConfiguration protocols. The data is stored in a singleton backed up on image snapshot.

Create the data type with the Attribute class and add the value for it. 

| wikiString |
wikiString := 'I have some kind of string value'. 
PWSeasidePrefsModel instance takeValue: wikiString forAttribute: (WAStringAttribute key: #currentString group: #wikidata).

The data is searchable by both key and group name.

Get a key with

PWSeasidePrefsModel instance valueAt: #currentString!

PWSeasidePrefsModel class
	instanceVariableNames: 'instance'!

!PWSeasidePrefsModel class methodsFor: 'as yet unclassified' stamp: 'chc 3/24/2016 09:47'!
initializeModel
"When installed with a script there is no data in the persistence. This adds default values to the singleton."
	PWSeasidePrefsModel instance takeValue: 'off' forAttribute: (WAStringAttribute key: #render group: #wikidata).
	PWSeasidePrefsModel instance takeValue: 8624 forAttribute: (WANumberAttribute key: #port group: #server).
	PWSeasidePrefsModel instance takeValue: 'admin' forAttribute: (WAStringAttribute key: #username group: #server).
	PWSeasidePrefsModel instance takeValue: 'pegwiki' forAttribute: (WAStringAttribute key: #password group: #server).
	PWSeasidePrefsModel instance takeValue: '_ Hello San Francisco' forAttribute: (WAStringAttribute key: #currentString group: #wikidata).! !

!PWSeasidePrefsModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:22'!
instance
	^ instance ifNil: [ instance _ self basicNew initialize ]! !

!PWSeasidePrefsModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:23'!
new
	^ self instance! !

!PWSeasidePrefsModel methodsFor: 'as yet unclassified' stamp: 'chc 3/23/2016 09:49'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		with: (WANumberAttribute key: #port group: #server)
		with: (WAStringAttribute key: #currentString group: #wikisyntax)
		"with: (WAStringAttribute key: #render group: #authentication)"! !

!WAUserConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/17/2005 00:27'!
initialize
	self allInstances do: [:ea | ea instVarNamed: 'ancestors' put: (ea ancestors collect: [:c  | [c instVarNamed: 'parent'] ifError: [c]])] 
	! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
allPotentialAncestors
	^ WASystemConfiguration allSubclasses collect: [:ea | ea new]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clear
	values _ Dictionary new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
initialize
	super initialize.
	values _ Dictionary new.
	ancestors _ OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues
	| dict |
	dict _ Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].
		
	^ dict! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAConfigurationAttribute commentStamp: 'chc 3/22/2016 09:25' prior: 0!
These are classes taken from the Seaside framework from its configuration persistence. !

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]
! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
key: keySymbol group: groupSymbol
	^ self basicNew initializeWithKey: keySymbol group: groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
initializeWithKey: keySymbol group: groupSymbol
	key _ keySymbol.
	group _ groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:28'!
stringForValue: anObject
	^ anObject displayString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
valueFromString: aString
	self subclassResponsibility ! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options _ aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:29'!
valueFromString: aString
	^ self options
		detect: [:ea | ea displayString = aString]
		ifNone: [self error: 'No matching list option']! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:02'!
accept: aVisitor with: anObject
	^ aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

Object subclass: #WAPreference
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WAPreference subclass: #WABooleanPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WABooleanPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:50'!
renderOn: html
	html booleanMenuOn: #value of: self! !

WAPreference subclass: #WAListPreference
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAListPreference class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key: aSymbol value: anObject options: aCollection
	^ (self key: aSymbol value: anObject) options: aCollection! !

!WAListPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:50'!
options: aCollection
	options _ aCollection! !

!WAListPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:51'!
renderOn: html
	html selectFromList: options selected: value callback: [:v | value _ v]! !

WAPreference subclass: #WANumberPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WANumberPreference methodsFor: 'as yet unclassified' stamp: 'JF 6/10/2003 16:32'!
renderOn: html
	html attributes size: (value asString size max: 10).
	html textInputWithValue: (value asString) callback: [:v | self value: v asNumber]! !

!WAPreference class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key: aSymbol value: anObject
	^ self new
		key: aSymbol;
		value: anObject! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key
	^ key! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key: aSymbol
	key _ aSymbol! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:49'!
renderOn: html
	html render: value! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:48'!
value
	^ value! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'JF 6/10/2003 16:31'!
value: anObject
	value _ anObject! !

WAPreference subclass: #WAStringPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAStringPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:49'!
renderOn: html
	html attributes size: (value size max: 10).
	html textInputOn: #value of: self.! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAConfigurationTest methodsFor: 'as yet unclassified' stamp: 'mb 4/23/2006 15:15'!
testLinearization
	"from http://www.webcom.com/haahr/dylan/linearization-oopsla96.html"
	| root boat dayBoat wheelBoat engineLess pedalWheelBoat smallMultihull smallCatamaran pedalo |
	root _ WAUserConfiguration new.
	boat _ WAUserConfiguration new addAncestor: root; yourself.
	dayBoat _ WAUserConfiguration new addAncestor: boat; yourself.
	wheelBoat _ WAUserConfiguration new addAncestor: boat; yourself.
	engineLess _ WAUserConfiguration new addAncestor: dayBoat; yourself.
	pedalWheelBoat _ WAUserConfiguration new addAncestor: engineLess; addAncestor: wheelBoat; yourself.
	smallMultihull _ WAUserConfiguration new addAncestor: dayBoat; yourself.
	smallCatamaran _ WAUserConfiguration new addAncestor: smallMultihull; yourself.
	pedalo _ WAUserConfiguration new addAncestor: pedalWheelBoat; addAncestor: smallCatamaran; yourself.

	self assert: pedalWheelBoat allAncestors = (Array with: engineLess with: dayBoat with: wheelBoat with: boat with: root).
	self assert: smallCatamaran allAncestors = (Array with: smallMultihull with: dayBoat with: boat with: root).
	self assert: pedalo allAncestors = ((Array with: pedalWheelBoat with: engineLess with: smallCatamaran with: smallMultihull), (Array with: dayBoat with: wheelBoat with: boat with: root)).! !
WAGlobalConfiguration initialize!
WAUserConfiguration initialize!
